/*====================================
/* ローリング・ストーン
/* Oh!X 1990/11
/* バグ修正 2013 AIG-Soft
// V3.20以降専用
/*====================================

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
	KEY_CHECK='C'
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
//width(0)
//tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------

int i,fpl=0,cy=0,demo=0,win
dim int card(31),hand(127),ba(3)
dim str nam(4)={"うさぎさん","ぶたさん","ねこさん","　あなた"}
if not isLocalizeJapan() then {
	nam={"Rabit"," Dog"," Cat"," You"}
}
dinit()

// 音声データ読み込み
int snd_pasa=a_setPlayData("rol1.mp3")
int snd_boo =a_setPlayData("rol2.mp3")

while YES
	cls():wipe()
	oinit()
	sfl()
	deal()
	allput()
	win=game()
	gover(win)
endwhile

// 音声バッファー開放
a_end(snd_pasa)
a_end(snd_boo)

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()

end

/*====================================

func gover(n;int)
int i
	for i=0 to 3:ba(i)=0:next:fpl=n
	locate(10,20)
	print "ＧＡＭＥ　ＯＶＥＲ　" ;nam(n); localizedString("の勝ちです"," win")
	if demo=0 then {
		hitKey(NO)
	} else {
		wrt(20)
	}
endfunc

/*====================================

func dinit()
/* 画面初期化
int i
	randomize(val(right$(time$,2)))
	setgPalet16X68(1,&h000000ff)
	//palet(1,1)
	apage(GPAGE3)
	fill16X68(0,0,511,511,8)
	symbol16X68(351,5,"rolling stone",1.5, 0,FONT,FNTSZ)
	symbol16X68(350,4,"rolling stone",1.5,15,FONT,FNTSZ)
	apage(GPAGE1):namput()
	apage(GPAGE0)
endfunc

/*====================================

func namput()
/* プレイヤーの名前表示
int i,y
	gColor16X68(15)
	for i=0 to 3
		y=asky(i)
		symbolt(0,y,nam(i),FONT,FNTSZ)
	next
endfunc

/*====================================

func oinit()
/* カードイニシャライズ
int i,j=1
	for i=0 to 31
		card(i)=j
		if j mod MAX_TRUMP=1 then j=j+6 else j=j+1
	next
endfunc

/*====================================

func sfl()
/* シャッフル
int a,b,c,i
	for i=0 to 99
		a=rnd()*32
		b=rnd()*32
		c=card(a)
		card(a)=card(b)
		card(b)=c
	next
endfunc

/*====================================

func deal()
/* カードを配る
int i,j=0
	for i=0 to 3
		for j=0 to 7
			hand(i*32+j)=card(i*8+j)
		next
	next
	sort()
endfunc

/*====================================

func plhand(pl;int)
/* プレイヤーの手札表示
int i,k=0
	k=askkz(pl)
	for i=0 to k-1
		cdput(pl,i,1)
	next
endfunc

/*====================================

func cdput(pl;int,n;int,sound;int)
/* カード1枚表示
int c,y,sp
	sp=asksp(pl)
	if pl=3 then c=hand(pl*32+n) else c=0
	y=asky(pl)
	line16X68(n*sp+15,y,n*sp+15,y+CARD_WY-1,0)
	cardPut(n*sp+16,y,c,NO)
	if sound then oto(snd_pasa)
endfunc

/*====================================

func int asksp(pl;int)
/* カードを置く間隔を調べる
int a
	float wmax=300
	a=48/(askkz(pl)*48/wmax)
	if a>48 then a=48
	return(a)
endfunc

/*====================================

func int askkz(pl;int)
/* 手札の数を数える
int i,j
	j=pl*32
	for i=j to j+31
		if hand(i)=0 then break
	next
	return(i-j)
endfunc

/*====================================

func oto(no;int)
/* 効果音
	a_play(no)
endfunc

/*====================================

func int asky(pl;int)
/* カードのＹ座標
	if pl=3 then return(370)
	return(pl*CARD_WY+30)
endfunc

/*====================================

func allput()
/* 4人の手札を表示
int i
	for i=0 to 3
		plhand(i)
	next
endfunc

/*====================================

func hshand(pl;int)
/* 手札を高速表示
int c,i,k,s,x,y
	y=asky(pl):s=asksp(pl):k=askkz(pl)
	fill16X68(16,y,349,y+CARD_WY-1,0)
	for i=0 to k-1
		x=i*s+16
		if pl=3 then c=hand(pl*32+i) else c = 0
		line16X68(x-1,y,x-1,y+CARD_WY-1,0)
		cardPut(x,y,c,NO)
	next
endfunc

/*====================================

func cdrop(pl;int,n;int)
/* 手札を1枚捨てる
int a,x,y
	a=asksp(pl)
	x=a*n+16
	y=asky(pl)
	if askkz(pl)=n+1 then a=48
	fill16X68(x,y,x+a,y+CARD_WY,0)
	if n>0 then cdput(pl,n-1,0)
	oto(snd_pasa)
	cardPut(350,y,hand(pl*32+n),NO)
	hand(pl*32+n)=0
	seiri(pl)
endfunc

/*====================================

func seiri(pl;int)
/* 手札の整理
int i,j=0,k
	dim int a(31)
	for i=0 to 31:a(i)=0:next
	k=pl*32
	for i=0 to 31
		if hand(k+i)<>0 then {
			a(j)=hand(k+i)
			hand(k+i)=6
			j=j+1
		}
		next
		for i=0 to 31
		hand(k+i)=a(i)
	next
endfunc

/*====================================

func int suit(a;int)
/* カードのスートを調べる
	return((a-1)/MAX_TRUMP)
endfunc

/*====================================

func power(a;int)
/* カードの強さを調べる
	a=a mod MAX_TRUMP
	if a=0 then a=MAX_TRUMP
	if a=1 then a=MAX_TRUMP+1
	return(a)
endfunc

/*====================================

func sort()
/* 自分のハンドのソート
int a,i,j,n,o1,o2
	n=askkz(3)-1
	for i=1 to n
		o1=96:o2=97
		for j=1 to n
			if cpow(hand(o1))<cpow(hand(o2)) then {
				a=hand(o1)
				hand(o1)=hand(o2)
				hand(o2)=a
			}
			o1=o1+1:o2=o2+1
		next
	next
endfunc

/*====================================

func int cpow(n;int)
/* ソートするカードの評価
int s
	s=suit(n)
	switch s
		case 0:break
		case 1:break
		case 2:s=3:break
		case 3:s=2:break
	endswitch
	int a:a=power(n)-7+s*8
	return(a)
endfunc

/*====================================

func int game()
/* ゲーム
int pl,i,j,k
	while YES
		pl=fpl
		mark(pl)
		if drop(pl)=1 then break
		wrt(10)
		while YES
			pl=pl+1:if pl=4 then pl=0
			if pl=fpl then {
				fpl=nxtpl()
				baclr()
				wrt(10)
				break
			}
			mark(pl)
			if abs(drop(pl))=1 then break
			wrt(10)
		endwhile
		if askkz(pl)=0 then break
	endwhile
	return(pl)
endfunc

/*====================================

func mark(n;int)
/* プレイヤーの指示マーク
int y
	apage(GPAGE2)
	fill16X68(0,0,15,511 ,0)
	y=asky(n)
	fill16X68(1,y,15,y+CARD_WY-1,4)
	apage(GPAGE0)
endfunc

/*====================================

func int crbar()
/* カーソルバーの表示
int k,sp
	 k=askkz(3):// 手札の数
	sp=asksp(3):// カードを置く間隔
//	locate(0,32):print "手札の数=";k,"間隔=";sp

	// タッチ座標設定
	int y=asky(3):// 人間のカードの位置
	int i
	touchallcnt=0
	for i=0 to k-1
		touchNo(int(touchallcnt))=setTouchArea(i*sp+16,y,sp,CARD_WY,i+1,YES,0,0,0,0)
	next

	// 選択(cyはグローバル変数)
	repeat:cy=inkey():until cy<>0
	cy=cy-1:// キーコードとして＋1されているので
	//
	removeKeys():// その待ちの間にタッチキーエリアも解除する
	
//	repeat
//		fill16X68(16,470,400,473,0)
//		fill16X68(cy*sp+16,470,(cy+1)*sp+15,473,4)
//		k=kyin()
//		if k=6 then {
//			cy=cy+1
//			if cy>askkz(3)-1 then cy=0
//		}
//		if k=4 then {
//			cy=cy-1
//			if cy<0 then cy=askkz(3)-1
//		}
//	until k=5
	return(cy)
endfunc

/*====================================

func int nxtpl()
/* 次のプレイヤーの指定
int a=0,i,j
	j=power(ba(0))
	for i=1 to 3
		if power(ba(i))>j then a=i:j=power(ba(i))
	next
	return(a)
endfunc

/*====================================

func wrt(n;int)
/* 時間調整
	wait((17.0/201.0)*n)
//int i
//	for i=0 to 200*n
//	next
endfunc

/*====================================

func baclr()
/* 場のカード整理
int i,j,x,y
	for j=0 to 3
		if ba(j)=0 then break
	next
	for i=0 to 3
		y=asky(i)
		fill16X68(350,y,398,y+CARD_WY-1,0)
		if ba(i)>0 then oto(snd_pasa)
		if j=4 then {
			x=rnd()*40+420
			y=rnd()*80+300
			cardPut(x,y,ba(i),NO)
		}
		ba(i)=0
	next
endfunc

/*====================================

func int drop(pl;int)
/* カードのドロップ（メイン）
	if pl=fpl then {
		return(drop1(pl))
	}
	return(drop2(pl))
endfunc

/*====================================

func int drop1(pl;int)
/* 最初の人のドロップ
int k,n
	k=askkz(pl)
	if pl=3 and demo=0 then n=crbar() else n=rnd()*k
	ba(pl)=hand(pl*32+n)
	cdrop(pl,n)
	if askkz(pl)<>0 then {
		hshand(pl)
		return(0)
	}
	return(1)
endfunc

/*====================================

func int drop2(pl;int)
/* 2人目以降のドロップ
int i,k,s
	s=suit(ba(fpl))
	k=askkz(pl)
	for i=0 to k-1
		if suit(hand(pl*32+i))=s then break
	next
	if i=k then {
		baget(pl)
		return(-1)
	}
	return(drop21(pl,i))
endfunc

/*====================================

func int drop21(pl;int,n;int)
/* ドロップ処理
int k
	if pl=3 and demo=0 then n=drop22(suit(hand(96+n)))
	ba(pl)=hand(pl*32+n)
	cdrop(pl,n)
	if askkz(pl)=0 then return(1)
	hshand(pl)
	return(0)
endfunc

/*====================================

func int drop22(s;int)
/* ドロップ処理（人間用）
int a,n
	while YES
		n=crbar()
		a=suit(hand(96+n))
		if a=a then break
		oto(snd_boo)
	endwhile
	return(n)
endfunc

/*====================================

func baget(pl;int)
/* 場のカードを拾う
int i,k
	if pl<3 then {
	k=askkz(pl)+pl*32
	for i=0 to 3
		hand(i+k)=ba(i)
		next
		seiri(pl)
	} else {
		bins()
	}
	baclr():fpl=pl
	hshand(pl)
	wrt(10)
endfunc

/*====================================

func bins()
/* 場のカードを拾う（人間用）
int a,b,i,j,m,n
dim int hbf(31)
	for i=0 to 31:hbf(i)=0:next
	for i=0 to 3
		if ba(i)=0 then ba(i)=-1
	next
	for i=0 to 1
		for j=0 to 2
			if cpow(ba(j))<cpow(ba(j+1)) then {
				a=ba(j):ba(j)=ba(j+1):ba(j+1)=a
			}
		next
	next
	m=96:n=0:a=hand(m):b=ba(n)
	for i=0 to 31
		if a=0 and b=-1 then break
		if a=0  then hbf(i)=b:n=n+1:b=ba(n)  :continue
		if b=-1 then hbf(i)=a:m=m+1:a=hand(m):continue
		if cpow(a)<cpow(b) then hbf(i)=b:n=n+1:b=ba(n):continue
		hbf(i)=a:m=m+1:a=hand(m)
	next
	for i=0 to 31:hand(96+i)=hbf(i):next
	for i=0 to 3
		if ba(i)=-1 then ba(i)=0
	next
endfunc

//****************************************************************
// 補助関数
//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
